const Main = imports.ui.main;
const Me = imports.misc.extensionUtils.getCurrentExtension();
const { Gio } = imports.gi;
const Log = Me.imports.modules.log;
const Panel = Me.imports.modules.panel43;
var Extension = class Extension {
    constructor() {
        this.gpuModeIndicatorInstance = null;
        this.quickToggles = null;
        this.systemMenu = null;
    }
    async enable() {
        Gio.Resource.load(`${Me.path}/resources/org.gnome.Shell.Extensions.supergfxctl-gex.gresource`)._register();
        this.systemMenu = Main.panel.statusArea.quickSettings;
        if (typeof this.systemMenu == "undefined") {
            Log.raw("init", "system menu is not defined");
            return false;
        }
        this.gpuModeIndicatorInstance = new Panel.gpuModeIndicator43();
        this.quickToggles = new Panel.gpuModeIndicator();
    }
    populate() {
        this.gpuModeIndicatorInstance._indicator = this.gpuModeIndicatorInstance._addIndicator();
        this.gpuModeIndicatorInstance._indicator.visible = true;
        this.gpuModeIndicatorInstance.quickSettingsItems.push(this.quickToggles);
        this.systemMenu._indicators.remove_child(this.systemMenu._system);
        this.systemMenu._indicators.add_child(this.gpuModeIndicatorInstance);
        this.systemMenu._addItems(this.gpuModeIndicatorInstance.quickSettingsItems);
        this.systemMenu._indicators.add_child(this.systemMenu._system);
    }
    disable() {
        this.quickToggles.stop();
        this.quickToggles.destroy();
        this.quickToggles = null;
        this.gpuModeIndicatorInstance.destroy();
        this.gpuModeIndicatorInstance = null;
    }
}
function init() {
    supergfxctlGexExtensionInstance = new Extension();
    return supergfxctlGexExtensionInstance;
}
//# sourceMappingURL=extension.js.map